| Version: 3.0.4

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Modules Pages
Public Member Functions | Protected Member Functions | List of all members
wxDataViewRenderer Class Referenceabstract
Class List by Category » wxDataViewCtrl Related Classes

`#include <wx/dataview.h>`

Inheritance diagram for wxDataViewRenderer:
[legend]

## Detailed Description

This class is used by wxDataViewCtrl to render the individual cells.

One instance of a renderer class is owned by a wxDataViewColumn. There is a number of ready-to-use renderers provided:

- wxDataViewTextRenderer,
- wxDataViewIconTextRenderer,
- wxDataViewToggleRenderer,
- wxDataViewProgressRenderer,
- wxDataViewBitmapRenderer,
- wxDataViewDateRenderer,
- wxDataViewSpinRenderer.
- wxDataViewChoiceRenderer.

Additionally, the user can write their own renderers by deriving from wxDataViewCustomRenderer.

The wxDataViewCellMode and wxDataViewCellRenderState flags accepted by the constructors respectively controls what actions the cell data allows and how the renderer should display its contents in a cell.

##

Library: wxAdvanced
Category: wxDataViewCtrl Related Classes

## Public Member Functions

| wxDataViewRenderer (const wxString &varianttype, wxDataViewCellMode mode=wxDATAVIEW_CELL_INERT, int align=wxDVR_DEFAULT_ALIGNMENT)
| Constructor. More...
void | EnableEllipsize (wxEllipsizeMode mode=wxELLIPSIZE_MIDDLE)
| Enable or disable replacing parts of the item text with ellipsis to make it fit the column width. More...
void | DisableEllipsize ()
| Disable replacing parts of the item text with ellipsis. More...
virtual int | GetAlignment () const
| Returns the alignment. More...
wxEllipsizeMode | GetEllipsizeMode () const
| Returns the ellipsize mode used by the renderer. More...
virtual wxDataViewCellMode | GetMode () const
| Returns the cell mode. More...
wxDataViewColumn * | GetOwner () const
| Returns pointer to the owning wxDataViewColumn. More...
virtual bool | GetValue (wxVariant &value) const =0
| This methods retrieves the value from the renderer in order to transfer the value back to the data model. More...
wxString | GetVariantType () const
| Returns a string with the type of the wxVariant supported by this renderer. More...
virtual void | SetAlignment (int align)
| Sets the alignment of the renderer's content. More...
void | SetOwner (wxDataViewColumn *owner)
| Sets the owning wxDataViewColumn. More...
virtual bool | SetValue (const wxVariant &value)=0
| Set the value of the renderer (and thus its cell) to value. More...
virtual bool | Validate (wxVariant &value)
| Before data is committed to the data model, it is passed to this method where it can be checked for validity. More...
virtual bool | HasEditorCtrl () const
virtual wxWindow * | CreateEditorCtrl (wxWindow *parent, wxRect labelRect, const wxVariant &value)
virtual bool | GetValueFromEditorCtrl (wxWindow *editor, wxVariant &value)
virtual bool | StartEditing (const wxDataViewItem &item, wxRect labelRect)
virtual void | CancelEditing ()
virtual bool | FinishEditing ()
wxWindow * | GetEditorCtrl ()
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined. More...
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined. More...

## Protected Member Functions

wxDataViewCtrl * | GetView () const
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...

## Additional Inherited Members

Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

wxDataViewRenderer::wxDataViewRenderer | ( | const wxString & | varianttype,
|  | wxDataViewCellMode | mode = `wxDATAVIEW_CELL_INERT`,
|  | int | align = `wxDVR_DEFAULT_ALIGNMENT`
| ) |  |

Constructor.

## Member Function Documentation

virtual void wxDataViewRenderer::CancelEditing | ( |  | ) |

virtual

virtual wxWindow* wxDataViewRenderer::CreateEditorCtrl | ( | wxWindow * | parent,
|  | wxRect | labelRect,
|  | const wxVariant & | value
| ) |  |

virtual

Reimplemented in wxDataViewCustomRenderer.

void wxDataViewRenderer::DisableEllipsize | ( |  | ) |

Disable replacing parts of the item text with ellipsis.

If ellipsizing is disabled, the string will be truncated if it doesn't fit.

This is the same as

EnableEllipsize(wxELLIPSIZE_NONE)

.

Since
  2.9.1

void wxDataViewRenderer::EnableEllipsize | ( | wxEllipsizeMode | mode = `wxELLIPSIZE_MIDDLE` | ) |

Enable or disable replacing parts of the item text with ellipsis to make it fit the column width.

This method only makes sense for the renderers working with text, such as wxDataViewTextRenderer or wxDataViewIconTextRenderer.

By default wxELLIPSIZE_MIDDLE is used.

Parameters

  mode | Ellipsization mode, use wxELLIPSIZE_NONE to disable.

Since
  2.9.1

virtual bool wxDataViewRenderer::FinishEditing | ( |  | ) |

virtual

virtual int wxDataViewRenderer::GetAlignment | ( |  | ) | const

virtual

Returns the alignment.

See SetAlignment()

wxWindow* wxDataViewRenderer::GetEditorCtrl | ( |  | ) |

wxEllipsizeMode wxDataViewRenderer::GetEllipsizeMode | ( |  | ) | const

Returns the ellipsize mode used by the renderer.

If the return value is wxELLIPSIZE_NONE, the text is simply truncated if it doesn't fit.

See also
  EnableEllipsize()

virtual wxDataViewCellMode wxDataViewRenderer::GetMode | ( |  | ) | const

virtual

Returns the cell mode.

wxDataViewColumn* wxDataViewRenderer::GetOwner | ( |  | ) | const

Returns pointer to the owning wxDataViewColumn.

virtual bool wxDataViewRenderer::GetValue | ( | wxVariant & | value | ) | const

pure virtual

This methods retrieves the value from the renderer in order to transfer the value back to the data model.

Returns false on failure.

virtual bool wxDataViewRenderer::GetValueFromEditorCtrl | ( | wxWindow * | editor,
|  | wxVariant & | value
| ) |  |

virtual

Reimplemented in wxDataViewCustomRenderer.

wxString wxDataViewRenderer::GetVariantType | ( |  | ) | const

Returns a string with the type of the wxVariant supported by this renderer.

wxDataViewCtrl* wxDataViewRenderer::GetView | ( |  | ) | const

protected

virtual bool wxDataViewRenderer::HasEditorCtrl | ( |  | ) | const

virtual

Reimplemented in wxDataViewCustomRenderer.

virtual void wxDataViewRenderer::SetAlignment | ( | int | align | ) |

virtual

Sets the alignment of the renderer's content.

The default value of `wxDVR_DEFAULT_ALIGMENT` indicates that the content should have the same alignment as the column header.

The method is not implemented under OS X and the renderer always aligns its contents as the column header on that platform. The other platforms support both vertical and horizontal alignment.

void wxDataViewRenderer::SetOwner | ( | wxDataViewColumn * | owner | ) |

Sets the owning wxDataViewColumn.

This is usually called from within wxDataViewColumn.

virtual bool wxDataViewRenderer::SetValue | ( | const wxVariant & | value | ) |

pure virtual

Set the value of the renderer (and thus its cell) to value.

The internal code will then render this cell with this data.

virtual bool wxDataViewRenderer::StartEditing | ( | const wxDataViewItem & | item,
|  | wxRect | labelRect
| ) |  |

virtual

virtual bool wxDataViewRenderer::Validate | ( | wxVariant & | value | ) |

virtual

Before data is committed to the data model, it is passed to this method where it can be checked for validity.

This can also be used for checking a valid range or limiting the user input in a certain aspect (e.g. max number of characters or only alphanumeric input, ASCII only etc.). Return false if the value is not valid.

Please note that due to implementation limitations, this validation is done after the editing control already is destroyed and the editing process finished.